<?php if(!defined('PLX_ROOT')) exit;
	/**
		* Plugin 			StaticMiniForum
		*
		* @CMS required			PluXml 
		*
		* @version			2.0.1
		* @date				29/11/2024
		* @author 			G.Cyrille
		░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░
		░       ░░  ░░░░░░░  ░░░░  ░  ░░░░  ░░      ░░       ░░░      ░░  ░░░░░░░        ░░      ░░░░░   ░░░  ░        ░        ░
		▒  ▒▒▒▒  ▒  ▒▒▒▒▒▒▒  ▒▒▒▒  ▒▒  ▒▒  ▒▒  ▒▒▒▒  ▒  ▒▒▒▒  ▒  ▒▒▒▒  ▒  ▒▒▒▒▒▒▒▒▒▒  ▒▒▒▒  ▒▒▒▒▒▒▒▒▒▒    ▒▒  ▒  ▒▒▒▒▒▒▒▒▒▒  ▒▒▒▒
		▓       ▓▓  ▓▓▓▓▓▓▓  ▓▓▓▓  ▓▓▓    ▓▓▓  ▓▓▓▓  ▓       ▓▓  ▓▓▓▓  ▓  ▓▓▓▓▓▓▓▓▓▓  ▓▓▓▓▓      ▓▓▓▓▓  ▓  ▓  ▓      ▓▓▓▓▓▓  ▓▓▓▓
		█  ███████  ███████  ████  ██  ██  ██  ████  █  ███████  ████  █  ██████████  ██████████  ████  ██    █  ██████████  ████
		█  ███████        ██      ██  ████  ██      ██  ████████      ██        █        ██      ██  █  ███   █        ████  ████
		█████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████
	**/
	class StaticMiniForum extends plxPlugin {
		
		
		
		const BEGIN_CODE = '<?php' . PHP_EOL;
		const END_CODE = PHP_EOL . '?>';
		public $lang = '';
		public $colors = array(
		"colors1" => array("#230571","#8e006d","#0040a4","#00b6b6","#00cbec","#00a777","#ff9300","#d7002c","#eb8096","#f5c0cb"),
		"colors2" => array("#ff3130","#ff8800","#ffca00","#4cd95d","#34b2dc","#0088ff","#a54eca","#e0008e","#757575","#0dff00"),
		"colors3" => array("#802d2f","#ff595e","#ff924c","#ffca3a","#c5ca30","#8ac926","#52a675","#1982c4","#4267ac","#6a4c93"),
		"colors4" => array("#ff595e","#ff924c","#ffca3a","#c5ca30","#8ac926","#52a675","#1982c4","#4267ac","#6a4c93","#d677b8"),
		"colors5" => array("#ff595e","#ff924c","#ffca3a","#c5ca30","#8ac926","#52a675","#1982c4","#4267ac","#6a4c93","#b5a6c9"),
		"colors6" => array("#3646c4","#dd2a18","#23ac07","#241517","#de55aa","#922e1e","#e8cd23","#291465","#1a6a06","#660f0f"),
		"colors7" => array("#ff5959","#ff8922","#e6a800","#2ad607","#00b5d9","#5c59ff","#c900c6","#ff00f2","#7d4545","#080707"),
		"colors8" => array("#16171c","#f7d826","#eb870d","#8804e0","#d4210d","#9c0000","#82e80d","#00ad2b","#36b4fc","#1628cf"),
		"colors9" => array("#ff3c3c","#2e69ff","#0fff1f","#fffb00","#06f7ff","#ad16ff","#ff8cd7","#17dbbb","#ff08a0","#ff9021"),
		);
		public $HTMLletterBadge='<b title="#member" style="margin:.2em 0;background:#bgColor;aspect-ratio:1;width:6rem;font-size:#sizech;display:grid;place-content:center;border-radius:50%;color:white;">#ucWL</b>';
		# Tableau des profils
		public $memberProfils = array();
		public $version = 'V 2.0.1';
		
		
		
		public function __construct($default_lang) {
			# appel du constructeur de la classe plxPlugin (obligatoire)
			parent::__construct($default_lang);			
			
			# droits pour accèder à la page config.php du plugin
			$this->setConfigProfil(PROFIL_ADMIN, PROFIL_MANAGER);	
			
			$captcha = $this->getParam('captcha') ==''   ?   '0' : $this->getParam('captcha') ;
			$statics = $this->getParam('statics') ==''   ?   '0' : $this->getParam('statics') ;			
			
			# Declaration des hooks		
			$this->addHook('AdminPrepend', 'AdminPrepend');	
			$this->addHook('AdminTopBottom', 'AdminTopBottom');
			$this->addHook('AdminTopEndHead', 'AdminTopEndHead');
			$this->addHook('AdminAuthPrepend', 'AdminAuthPrepend');
			$this->addHook('AdminAuthTop', 'AdminAuthTop');			
			$this->addHook('AdminAuthEndHead', 'AdminAuthEndHead');
			$this->addHook('AdminAuthEndBody', 'AdminAuthEndBody');
			$this->addHook('AdminUsersTop', 'AdminUsersTop');
			$this->addHook('plxShowStaticListEnd', 'plxShowStaticListEnd');
			$this->addHook('ThemeEndHead', 'ThemeEndHead');
			$this->addHook('ThemeEndBody','ThemeEndBody');
			$this->addHook('wizard', 'wizard');
			$this->addHook('plxShowStaticContent', 'plxShowStaticContent');	
			// 'plxShowLastComList'
			$this->memberProfils = array(			
			0 => $this->getLang('L_PROFIL_ADMIN'),
			1 => $this->getLang('L_PROFIL_MANAGER'),
			2 => $this->getLang('L_PROFIL_MODERATOR'),
			3 => $this->getLang('L_PROFIL_EDITOR'),
			4 => $this->getLang('L_PROFIL_WRITER'),
			5 => $this->getLang('L_PROFIL_FORUM')
			);
		}
		
		
		#code à exécuter à la désactivation du plugin
        public function OnDeactivate() {		
			#desactive les comptes visiteurs	
			$deactivateVisitors=simplexml_load_file(PLX_ROOT.PLX_CONFIG_PATH."users.xml") or die("Error: Cannot create object");
			foreach($deactivateVisitors->children() as $users) {
				if ( $users['profil'] =='5') {
					$users->attributes()->delete = '1';
				}
			} 
			$deactivateVisitors->asXml(PLX_ROOT.PLX_CONFIG_PATH."users.xml");

		}
		
        #code à exécuter à l’activation du plugin 
        public function OnActivate() { 
		
			$_SESSION['justactivated'.basename(__DIR__)] = true;
		
			#réactive compte visiteur s'il y en a
			$reactivateVisitors=simplexml_load_file(PLX_ROOT.PLX_CONFIG_PATH."users.xml") or die("Error: Cannot create object");
			foreach($reactivateVisitors->children() as $users) {
				if (( $users['profil'] =='5') and ( $users['delete'] =='1') ) {
					$users->attributes()->delete = '0';
				}
			} 
			$reactivateVisitors->asXml(PLX_ROOT.PLX_CONFIG_PATH."users.xml");			
		}	
		
		public function AdminAuthEndHead(){
		?>
        <link rel="stylesheet" type="text/css" href="<?php echo PLX_PLUGINS . __CLASS__ ?>/css/auth.css" media="screen" />
        <?php
			if(isset($_SESSION['pageRequest'])) {
			?>
			<style>			
				h1.h5.text-center strong {display: none}
				h1.h5.text-center::before {content:'CONNEXION AU FORUM'}
			</style>
			<?php
			}
		}
        public function AdminAuthPrepend(){#save new on post
		echo '<?php #' . __CLASS__ . '::' . __FUNCTION__ . PHP_EOL; ?>
        #New user
        if(!empty($_POST) AND !empty($_POST['update']) AND !empty($_POST['name']) AND !empty($_POST['wall-e']) AND !empty($_POST['password']) AND !empty($_POST['login']) AND empty($_POST['email'])) {
        $posts = array();
        $posts['userNum'] = array();
        $posts['newuser'] = 'true';
        $posts['update'] = $_POST['update'];
        # On récupère le dernier identifiant
        $a = array_keys($plxAdmin->aUsers);
        rsort($a);
        $new_userid = str_pad($a['0']+1, 3, "0", STR_PAD_LEFT);
        # On integre le nouvel utilisateur
        $posts['userNum'][] = $new_userid;
        $posts[$new_userid.'_newuser'] = 'true';
        $posts[$new_userid.'_name'] = $_POST['name'];
        $posts[$new_userid.'_infos'] = '';
        $posts[$new_userid.'_login'] = $_POST['login'];
        $posts[$new_userid.'_password'] = $_POST['password'];
        $posts[$new_userid.'_email'] = $_POST['wall-e'];#Real mail field ;)
        $posts[$new_userid.'_profil'] = PROFIL_FORUM;
        $posts[$new_userid.'_active'] = 1;
        $_SESSION['user'] = '1000';#need in editUsers()
        #On enregistre le nouvel utilisateur
        if(!$plxAdmin->editUsers($posts)) {
        $msgSignUp = $_SESSION['error'];
        unset($_SESSION['error'], $_POST['login'], $_POST['password']);
        $errorSignUp = 'alert red';
        }
        unset($_SESSION['user']);#remove fake
        }
        ?><?PHP
		}
        public function AdminAuthBegin(){#get != 'newMember=1' (<5.8 == AdminAuthTop)
		echo '<?php '; ?>
        if($plxAdmin->get == 'newMember=1'){
        ob_start();
        }
        ?><?php
		}
        public function AdminAuthEndBody(){#get == 'new=1' or all
            echo '<?php
            $label='.intval($this->getParam('label')).';
            $showAll='.intval($this->getParam('all')).';
            ';
		?>
        $formSignUpForum = '';
        if($showAll OR $plxAdmin->get == 'newMember=1') {# get == newMember=1
        if(!$showAll) ob_end_clean();
        define('L_BACK_SIGNUP_FORUM', '<?php $this->lang('L_BACK') ?>');
        define('L_SHIFT_SIGNUP_FORUM', '<?php $this->lang('L_SHIFT') ?>');
		define('L_PASSWORD_SIGNUP_FORUM', '<?php $this->lang('L_PASSWORD') ?>');
		include PLX_PLUGINS . '<?=__CLASS__?>' . DIRECTORY_SEPARATOR . 'form.signup.forum.php';
		}
		?><?php
		}		
		
		#ajout constante profil VIP
		public function AdminPrepend() {
			echo self::BEGIN_CODE;
		?>
		const PROFIL_FORUM = 5;	
		if(isset($_SESSION['profil']) && $_SESSION['profil'] =='5' && !isset($_SESSION['pageRequest'])) header('location: '.$plxAdmin->urlRewrite());
		<?php
            echo self::END_CODE;
		}		
		#On ajoute un profil utilisateur
        public function AdminUsersTop() {
			echo self::BEGIN_CODE;
		?>
		$plxMotor = plxMotor::getInstance();
		$plugin = $plxMotor->plxPlugins->aPlugins['<?= __CLASS__ ?>'];
		$VIP_Profil = $plugin->getLang('L_PROFIL_FORUM');				
		# Tableau des profils
		$aProfils[PROFIL_FORUM] = $VIP_Profil;
		<?php
            echo self::END_CODE;
		} 
		
	    #On renvoi le membre vers le forum demandé aprés authentification
        public function AdminTopEndHead() {
            echo self::BEGIN_CODE;
		?>				 
		if(isset($_SESSION['profil']) && isset($_SESSION['pageRequest']))  {
		$loc= $_SESSION['pageRequest'];
		unset($_SESSION['pageRequest']);
		echo header("location: ".htmlentities($loc));
		die;
		} 	
		<?php
            echo self::END_CODE;
		}
		
		public function ThemeEndBody() {
		echo '<?php  if($plxMotor->mode=="static") echo\'<script src="'.PLX_PLUGINS.__CLASS__.'/js/loadForm.js"></script>\'.PHP_EOL; ?>	';		
		}
		
		
		public function ThemeEndHead() {
		
			echo'<?php	
			if (!isset($_SESSION[\'profil\']) && ($plxMotor->mode === \'static\' )) $_SESSION[\'pageRequest\']= $_SERVER[\'REQUEST_URI\']; 
			
			?>';
			#gestion multilingue
			if(defined('PLX_MYMULTILINGUE')) {		
				$plxMML = is_array(PLX_MYMULTILINGUE) ? PLX_MYMULTILINGUE : unserialize(PLX_MYMULTILINGUE);
				$langues = empty($plxMML['langs']) ? array() : explode(',', $plxMML['langs']);
				$string = '';
				foreach($langues as $k=>$v)	{
					$url_lang="";
					if($_SESSION['default_lang'] != $v) $url_lang = $v.'/';
					$string .= 'echo "\\t<link rel=\\"alternate\\" hreflang=\\"'.$v.'\\" href=\\"".$plxMotor->urlRewrite("?'.$url_lang.$this->getParam('url').'")."\" />\\n";';
				}
				echo '<?php if($plxMotor->mode=="'.$this->getParam('url').'") { '.$string.'} ?>';
			}
			// ajouter ici aux besoins vos propre codes (insertion balises link, script , ou autre)
		}
		
		/**
			* Méthode qui affiche un message si le plugin n'a pas la langue du site dans sa traduction
			* Ajout gestion du wizard si inclus au plugin
			* @return	stdio
			* @author	Stephane F / G.Cyrille
		**/
		public function AdminTopBottom() {			
			echo '<?php
			
			error_reporting(E_ALL ^ E_NOTICE );
			$file = PLX_PLUGINS."'.$this->plug['name'].'/lang/".$plxAdmin->aConf["default_lang"].".php";
			if(!file_exists($file)) {
			echo "<p class=\\"warning\\">'.basename(__DIR__).'<br />".sprintf("'.$this->getLang('L_LANG_UNAVAILABLE').'", $file)."</p>";
			plxMsg::Display();
			}
			?>';
			
			# affichage du wizard à la demande
			if(isset($_GET['wizard'])) {$_SESSION['justactivated'.basename(__DIR__)] = true;}
			# fermeture session wizard
			if (isset($_SESSION['justactivated'.basename(__DIR__)])) {
				unset($_SESSION['justactivated'.basename(__DIR__)]);
				$this->wizard();
			}			
		}
		
		/** 
			* Méthode wizard
			* 
			* Descrition	: Affiche le wizard dans l'administration
			* @author		: G.Cyrille
			* 
		**/
		# insertion du wizard
		public function wizard() {
			# uniquement dans les page d'administration du plugin.
			if(basename(
			$_SERVER['SCRIPT_FILENAME']) 			=='parametres_plugins.php' || 
			basename($_SERVER['SCRIPT_FILENAME']) 	=='parametres_plugin.php' || 
			basename($_SERVER['SCRIPT_FILENAME']) 	=='plugin.php'
			) 	{	
				include_once(PLX_PLUGINS.__CLASS__.'/lang/'.$this->default_lang.'-wizard.php');
			}
		}
		
		/** 
			* Méthode plxShowStaticInclude
			* 
			* Descrition	:
			* @author		: TheCrok
			* 
		**/
		public function plxShowStaticContent() {
			
			# insertion des commentaires et formulaire			
			echo self::BEGIN_CODE;
		?>
		ob_start();
		if(isset($_GET['backHome'])) {
		$_SESSION = array();
		session_destroy();
		header('location: index.php?static'.$this->staticId().'/'.$this->staticTitle());
		exit;
		}
		include( PLX_PLUGINS.'StaticMiniForum/assets/commentaires.php');
		$output .= ob_get_clean();
		<?php
			echo self::END_CODE;
		}
		
		/** 
			* Méthode HTMLbadge
			* 
			* Descrition	: Extrait capitale(s) et/ ou premiers lettres du nom du membre
			*				  Extrait une couleur $colors
			*				  creer un badge avec $HTMLletterBadge 
			* @author		: Gcyrillus
			* 
		**/		
		public 	function HTMLbadge($string,$patternColors, $HTMLletterBadge){
			$av='';
			$num4color=1;
			$alphabet = range('A', 'Z');
			$letters=preg_split("/(?=[A-Z])/", ucwords($string),-1);
			foreach($letters as $k) {
				$av .= mb_substr(trim($k), 0,1);
				$num4color = ($num4color + array_search(strtoupper($k), $alphabet));
			}
			$dataReplace=array('#bgColor','#size','#ucWL','#member');
			$replaceBy =array($patternColors[substr($num4color, -1)],3.5 / strlen($av),$av,$string);
			return str_replace($dataReplace, $replaceBy, $HTMLletterBadge).PHP_EOL;
		}
		
		/** 
			* Méthode patternToRGB
			* 
			* Descrition	: renvoi une image pour chaque pattern de couleur
			*
			* @author		: Gcyrillus
			* 
		**/		
		public function patternToRGB($pattern) {
			$bg=$pattern[0];
			$pattern =array_reverse($pattern);
			$pattern[]=$bg;
			$image = imagecreatetruecolor(200,20);
			$step=200;
			
			# ajout block couleurs
			foreach($pattern as $block ) {
				list($r,$g,$b) = array_map('hexdec', str_split(ltrim($block,'#'), 2));
				imagefilledrectangle($image, $step , 0 , 20, 20 ,	imagecolorallocate($image,$r,$g,$b ));
				$step = $step-20;
			}
			# renvoi l'image dans une balise <img src="data:image/image/png;base64,...">
			ob_start();
			imagePng($image);
			$base_64 = base64_encode(ob_get_clean());
			imagedestroy($image);			
			return '<img src="data:image/image/png;base64,'.$base_64.'">';
		}
	}												